<template>
  <file-pond v-if="!data.loading" 
    v-bind="{...properties, ...defaultProperties, ...LabelsEs}"
    :server="getServer()"
    :files.sync="data.filesFilePond" 
    @init="handleFilePondInit" 
    @activatefile="showFile"
    :beforeRemoveFile="beforeRemoveFile"
    ref="uploader"
    />
</template>

<script setup lang="ts">
import { ref, reactive, onMounted, watch, computed } from 'vue'
import type { Component } from 'vue';
import axios, { type AxiosResponse } from 'axios';
import Swal from 'sweetalert2'

// Import FilePond and plugin code
import VueFilePond from "vue-filepond";
import FilePondPluginFileValidateType from 'filepond-plugin-file-validate-type';
import FilePondPluginFileValidateSize from 'filepond-plugin-file-validate-size';
import FilePondPluginImagePreview from 'filepond-plugin-image-preview';
import FilePondPluginPdfPreview from "filepond-plugin-pdf-preview";

import type { FilePondFile as FilePondFileType, FilePond as FilePondType, ProgressServerConfigFunction } from "filepond";

// Import FilePond styles
import "filepond/dist/filepond.min.css";
import 'filepond-plugin-image-preview/dist/filepond-plugin-image-preview.css';
import LabelsEs from './LabelsEs';
import { FileDBResponse, StoreProceduresOptions, ServerConfig } from "./fileuploader";

var FilePond = {} as Component;
var pond: any = null;
const uploader = ref();
// var pond = ref<FilePondType | null>();

// const FilePond = VueFilePond(FilePondPluginFileValidateType, FilePondPluginImagePreview, FilePondPluginPdfPreview, FilePondPluginFileValidateSize) as Component;
// const pond = ref<FilePondType | null>();

const properties = defineProps({
  'urlServer': {
    type: String,
    required: false,
    default: null
  },
  'serverConfig': {
    type: ServerConfig,
    required: false,
    default: new ServerConfig
  },
  'allow-multiple': Boolean,
  'maxFiles': Number,
  'max-parallel-uploads': Number,
  'accepted-file-types': String,
  'credits': {
    type: String,
    default: ""
  },
  'disabled': {
    type: Boolean,
    default: false,
    required: false
  },
  'ftpPath': {
    type: String,
    required: false
  },
  'storeProceduresOptions': {
    type: StoreProceduresOptions,
    required: false
  },
  'allowRevert': {
    type: Boolean,
    default: true
  },
  'allowRemove': {
    type: Boolean,
    default: true
  },
  'maxFileSize': {
    type: String,
    default: "5MB"
    // default: "100KB"
  },
  'maxTotalFileSize': {
    type: String,
    default: "50MB"
    // default: "100KB"
  },
  'addImagePreview': {
    type: Boolean,
    default: true
  },
  'addPdfPreview': {
    type: Boolean,
    default: true
  },
  'grid': {
    type: Boolean,
    default: false
  },
});

const defaultProperties = {
  ref:"pond",
  name:"hcd_files",
  allowReplace: false,
  allowReorder: false,
  maxParallelUploads: 2,
  styleButtonRemoveItemPosition: "right",
  iconRemove: "<svg xmlns='http://www.w3.org/2000/svg' width='26' height='26' fill='currentColor' aria-hidden='true' viewBox='-5 -5 26 26'><path d='M5.5 5.5A.5.5 0 0 1 6 6v6a.5.5 0 0 1-1 0V6a.5.5 0 0 1 .5-.5zm2.5 0a.5.5 0 0 1 .5.5v6a.5.5 0 0 1-1 0V6a.5.5 0 0 1 .5-.5zm3 .5a.5.5 0 0 0-1 0v6a.5.5 0 0 0 1 0V6z'/><path fill-rule='evenodd' d='M14.5 3a1 1 0 0 1-1 1H13v9a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V4h-.5a1 1 0 0 1-1-1V2a1 1 0 0 1 1-1H6a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1h3.5a1 1 0 0 1 1 1v1zM4.118 4 4 4.059V13a1 1 0 0 0 1 1h6a1 1 0 0 0 1-1V4.059L11.882 4H4.118zM2.5 3V2h11v1h-11z'/></svg>",
  iconUndo: "<svg xmlns='http://www.w3.org/2000/svg' width='26' height='26' fill='currentColor' aria-hidden='true' viewBox='-5 -5 26 26'><path d='M5.5 5.5A.5.5 0 0 1 6 6v6a.5.5 0 0 1-1 0V6a.5.5 0 0 1 .5-.5zm2.5 0a.5.5 0 0 1 .5.5v6a.5.5 0 0 1-1 0V6a.5.5 0 0 1 .5-.5zm3 .5a.5.5 0 0 0-1 0v6a.5.5 0 0 0 1 0V6z'/><path fill-rule='evenodd' d='M14.5 3a1 1 0 0 1-1 1H13v9a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V4h-.5a1 1 0 0 1-1-1V2a1 1 0 0 1 1-1H6a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1h3.5a1 1 0 0 1 1 1v1zM4.118 4 4 4.059V13a1 1 0 0 0 1 1h6a1 1 0 0 0 1-1V4.059L11.882 4H4.118zM2.5 3V2h11v1h-11z'/></svg>",
}

// const emit = defineEmits<{
//   (e: 'newIdRelTablaReg', id_rel_tabla_reg: number | null): void
// }>();

var data = reactive({
  filesFilePond: [] as {
    source: string,
    options: {
      type: string
    }
  }[],
  loading: true as boolean,
  filesDB: [] as FileDBResponse[]
});

const gridCss = computed(() => {
  return (properties.grid)? "calc(50% - 0.5em)" : "100%";
})

onMounted(() => {
  data.loading = true;

  if(properties.addImagePreview && properties.addPdfPreview){
    FilePond = VueFilePond(FilePondPluginFileValidateType, FilePondPluginFileValidateSize, FilePondPluginImagePreview, FilePondPluginPdfPreview) as Component;
  } else if(properties.addImagePreview){
    FilePond = VueFilePond(FilePondPluginFileValidateType, FilePondPluginFileValidateSize, FilePondPluginImagePreview) as Component;
  } else if(properties.addPdfPreview){
    FilePond = VueFilePond(FilePondPluginFileValidateType, FilePondPluginFileValidateSize, FilePondPluginPdfPreview) as Component;
  } else {
    FilePond = VueFilePond(FilePondPluginFileValidateType, FilePondPluginFileValidateSize) as Component;
  }

  if(properties.urlServer != null){
    if(properties.ftpPath === undefined){
      throw new Error("Debe especificar la prop 'ftpPath'.");
    }

    if(properties.storeProceduresOptions === undefined){
      throw new Error("Debe especificar la prop 'storeProceduresOptions'.");
    } else {
      watch(() => properties.storeProceduresOptions!.id_rel_tabla_reg, async (newValue, oldValue) => {
        // console.log("watch", newValue != properties.storeProceduresOptions.id_rel_tabla_reg , newValue != oldValue);
        if(newValue != properties.storeProceduresOptions!.id_rel_tabla_reg || newValue != oldValue){
          data.loading = true;
          getAllDocuments();
          data.loading = false;
        }
      });
    }
    getAllDocuments();
  }
  pond = ref<FilePondType | null>();
  data.loading = false;
});

function getServer() {
  if(properties.urlServer != null){
    return {
      url: properties.urlServer,
      process: {
        // url: 'process',
        url: properties.serverConfig.process,
        method: 'POST',
        onload: (response: string) => {
          var data = JSON.parse(response);
          if(properties.storeProceduresOptions!.id_rel_tabla_reg == null){
            properties.storeProceduresOptions!.id_rel_tabla_reg = data.res.id_rel_tabla_reg;
            // emit("newIdRelTablaReg", data.res.id_rel_tabla_reg);
          }
          return data.res.id_doc_escan;
        },
        onerror: (response: any) => response.data,
        ondata: (formData: any) => {
          formData.append('ftpPath', properties.ftpPath);
          formData.append('prefijo_escan', properties.storeProceduresOptions!.prefijo_escan);
          formData.append('id_tipo_doc_escan', properties.storeProceduresOptions!.id_tipo_doc_escan);
          formData.append('id_tabla', properties.storeProceduresOptions!.id_tabla);
          formData.append('id_tabla_reg', properties.storeProceduresOptions!.id_tabla_reg);
          return formData;
        },
      },
      load: async (source: any, load: (file: File | Blob) => void, error: (errorText: string) => void, progress:ProgressServerConfigFunction, abort:() => void, headers:(headersString: string) => void) => {
        
        try {
          // Should request a file object from the server here 
          // var response: AxiosResponse = await axios.post(properties.urlServer + 'load', {
          var response: AxiosResponse = await axios.post(properties.urlServer + properties.serverConfig.load, {
            filePath: source
          },{responseType: 'blob'});
      
          var blob: Blob = response.data;

          // Can call the header method to supply FilePond with early response header string
          // https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/getAllResponseHeaders
          // headers(headersString);

          // Should call the progress method to update the progress to 100% before calling load
          // (endlessMode, loadedSize, totalSize)
          progress(true, 0, blob.size);

          // Should call the load method with a file object or blob when done
          load(blob);

        } catch (errorObject: any) {
          // Can call the error method if something is wrong, should exit after
          error(errorObject.menssage);
        }

        // Should expose an abort method so the request can be cancelled
        return {
          abort: () => {
            // User tapped cancel, abort our ongoing actions here

            // Let FilePond know the request has been cancelled
            abort();
          },
        };
      },
      remove: async (source: any, load: () => void, error: (errorText: string) => void) => {
        try {
          var fileDB: FileDBResponse | undefined = findFileByPath(source);
          if( typeof fileDB !== "undefined"){
            await axios.post(properties.urlServer + properties.serverConfig.remove, fileDB);

            Swal.fire(
              'Eliminado!',
              'El archivo fue eliminado.',
              'success'
            );
          } else {
            error("ocurrio un error 2");
          }
        } catch (errorObject: any) {
          // Can call the error method if something is wrong, should exit after
          error(errorObject.menssage);
        }
        load();
      },
      revert: async (uniqueFileId: any, load: () => void, error: (errorText: string) => void) => {
        // Should remove the earlier created temp file here
        try {
          var fileDB: FileDBResponse | undefined = findFileByPath(uniqueFileId);
          if( typeof fileDB !== "undefined"){
            await axios.post(properties.urlServer + properties.serverConfig.revert, fileDB);

            Swal.fire(
              'Eliminado!',
              'El archivo fue eliminado.',
              'success'
            );
          } else {
            error("ocurrio un error 2");
          }
          
        } catch (errorResponse) {
          // Can call the error method if something is wrong, should exit after
          error('Ocurrio un error al revertir');
        }
        // Should call the load method when done, no parameters required
        load();
      },
    }
  }
  return null;
}

function findFileByPath(path: string): FileDBResponse | undefined{
  return data.filesDB.find((elem: FileDBResponse) =>{
      return elem.arch_ruta == path;
  });
}

async function beforeRemoveFile(item: FilePondFileType){
  let result = await Swal.fire({
    title: '¿Estas seguro de eliminar este archivo?',
    text: "Esta accion no puede ser revertida!",
    icon: 'warning',
    showCancelButton: true,
    confirmButtonColor: '#3085d6',
    cancelButtonColor: '#d33',
    confirmButtonText: 'Eliminar',
    cancelButtonText: 'Cancelar'
  });
  return result.isConfirmed;
}

async function getAllDocuments(){
  data.filesFilePond = [];
  if(properties.storeProceduresOptions!.id_rel_tabla_reg != null){
    try {
      var response: AxiosResponse = await axios.post(properties.urlServer + 'getDocumentosEscaneados', {
        id_rel_tabla_reg: properties.storeProceduresOptions!.id_rel_tabla_reg
      });
    
      data.filesDB = response.data['res'];
      data.filesFilePond = [];
      data.filesDB.forEach(async (element: FileDBResponse) => {
        data.filesFilePond.push(
          {
            source: element.arch_ruta,
            options: {
              type: 'local'
            }
          }
        );
      });
     
    } catch (error) {
      console.log(error);
      throw new Error("Ocurrio un error al inicializar el Uploader. Sin conexion con el servidor.");
    }
  }
}

function handleFilePondInit(): void {
  // console.log('FilePond has initialized');
  // console.log(getFiles());
}

function showFile(item: FilePondFileType): void{
  let output: string = URL.createObjectURL(item.file);
  window.open(output);
}

// function findFileById(id_doc_escan: number): FileDBResponse | undefined{
//   return data.filesDB.find((elem: FileDBResponse) =>{
//       return Number(elem.id_doc_escan) == id_doc_escan;
//   });
// }

// function findFilePondFile(fileName: string): FilePondFileType| undefined{
//   console.log("findFilePondFile", fileName,pond.value!.getFiles() );
//   var files: FilePondFileType[] = pond.value!.getFiles();

//   return files.find((elem: FilePondFileType) => {
//     return elem.filename == fileName
//   });
// }

function getFiles(): FilePondFileType[]{
  const list: FilePondFileType[] = uploader.value!.getFiles();
  return list;
}

function removeFile(){
  return uploader.value!.removeFile();
}

defineExpose({
  getFiles,
  removeFile
})

</script>

<style>

.filepond--file-action-button {
    cursor: pointer;
}

.filepond--label-action {
    text-decoration-color: rgb(0, 165, 189);
}

/* .filepond--item-panel {
    border-radius: 50%;
    cursor: pointer !important 
} */

.filepond--item-panel {
    background-color: rgb(0, 165, 189);
}

.filepond--file {
    color: black;
}

.filepond--item {
    width: v-bind(gridCss);
}

.filepond--file-action-button {
    background-color: rgb(220, 53, 69);
}
</style>